# 启动方式: bash -i server_start.sh
# sudo password: 123456
# mongodb服务
pid=`ps ax|grep mongod|grep -v grep|awk '{print $1}'`
if [ -z ${pid} ]; then
    sudo mongod -f /etc/mongodb.conf --fork
fi

# CV服务
sudo supervisorctl start all

# NLP服务
cd /home/fxb/Shmeea/NLP/physics_repeat_check
conda activate dup_search
python restart_server.py

# 前端服务
cd /home/fxb/ksy/ksy_pages/backend/ksy_chachong_release
conda activate ksy_pages
pid=`ps ax|grep ksy_query_topic.py|grep -v grep|awk '{print $1}'`
if [ -z ${pid} ]; then
    sudo service nginx start
    nohup python3 ksy_query_topic.py &
fi